import shutil


def move_file(source, destination, overwrite=False):
    """
    Move a file from a source directory to a destination directory.
    :param source: The source file including path
    :param destination: The destination directory
    :param overwrite: A boolean indicating if existing files in the destination should be overwritten (default: False)
    """

    # Check if the source and destination paths exist
    if isfile(source) and isdir(destination):
        # Check if the file already exists in the destination path
        if isfile(destination):
            # Check if we want to overwrite the existing file in the destination path
            if overwrite:
                # Remove the existing file in the destination path
                remove_file(destination)
                # Move the file from the source path to the destination path
                shutil.move(source, destination)
            else:
                # Notify the user that the file already exists in the destination path
                print(f"File {source} already exists in the destination directory.")
        else:
            # Move the file from the source path to the destination path
            shutil.move(source, destination)
    else:
        # Notify the user that the source and/or destination paths are incorrect or do not exist
        print("The source or destination paths are incorrect or do not exist.")
