# -*- coding: utf-8 -*-
from setuphelpers import *

r"""
Usable WAPT package functions: install(), uninstall(), session_setup(), audit(), update_package()

"""
# Declaring global variables - Warnings: 1) WAPT context is only available in package functions; 2) Global variables are not persistent between calls
package_list = ["git-all", "git-lfs"]


def install():
    # Installing the package
    update_yum()
    for package_name in package_list:
        print("Installing package: %s" % package_name)
        install_yum(package_name)


def uninstall():
    # Uninstalling the package
    for package_name in package_list:
        print("Uninstalling package: %s" % package_name)
        uninstall_yum(package_name)
    autoremove_yum()


def update_package():
    # Declaring local variables
    result = False
    version = control.get_software_version()
    # url = "https://packages.debian.org/source/%s" % package_name

    # Changing version of the package
    if Version(version) > Version(control.get_software_version()):
        print("Software version updated (from: %s to: %s)" % (control.get_software_version(), Version(version)))
        result = True
    else:
        print("Software version up-to-date (%s)" % Version(version))
    control.version = "%s-%s" % (Version(version), control.version.split("-", 1)[-1])
    # control.set_software_version(version)
    control.save_control_to_wapt()

    # Validating update-package-sources
    return result
