# -*- coding: utf-8 -*-
from setuphelpers import *
import platform
import bs4 as BeautifulSoup

"""
Usable WAPT package functions: install(), uninstall(), session_setup(), audit(), update_package()

"""
# Declaring global variables - Warnings: 1) WAPT context is only available in package functions; 2) Global variables are not persistent between calls
package_name = "p7zip-full"


def install():
    # Installing the package
    print("Installing: %s" % package_name)
    install_apt(package_name)


def uninstall():
    # Uninstalling the package
    print("Uninstalling: %s" % package_name)
    uninstall_apt(package_name)
    uninstall_apt("p7zip")


def update_package():
    result = False
    # Getting proxy informations from WAPT settings
    proxies = get_proxies_from_wapt_console()
    if not proxies:
        proxies = get_proxies()

    # Specific app values
    url = "https://packages.debian.org/sid/amd64/p7zip-full/download"

    # Getting latest version from official website

    for u in bs_find_all(url, "a", proxies=proxies):
        if "ftp.fr.debian.org/debian" in u.text:
            latest_version = u["href"].split("+")[0].split("_")[-1]
            break

    print("Latest  version is: %s" % latest_version)

    # changing version of the package
    if Version(latest_version) != control.get_software_version():
        result = True
    control.version = "%s-%s" % (latest_version, control.version.split("-", 1)[-1])
    # control.set_software_version(version)
    control.save_control_to_wapt()

    # validating or not update-package-sources
    return result
