# -*- coding: utf-8 -*-
from setuphelpers import *
from setupdevhelpers import *
from waptutils import get_sha256
from urllib.parse import urlparse, urljoin, quote


def update_package():
    package_updated = False
    proxies = get_proxies_from_wapt_console()
    if not proxies:
        proxies = get_proxies()

    binaries_dict = {
        "bin_name": "sha256",
        # "bin_name": "sha256",
    }

    for bin_name in binaries_dict:
        # http is ok since we are verifying sha256
        download_url = "http://srvtemplates.ad.tranquil.it/binary_cache/" + quote(bin_name)
        sha256 = binaries_dict[bin_name]
        if isfile(bin_name):
            if get_sha256(bin_name) != sha256:
                remove_file(bin_name)
        print("Download URL is: %s" % download_url)
        if not isfile(bin_name):
            print("Downloading: %s" % bin_name)
            wget(download_url, bin_name, sha256=sha256, proxies=proxies)
        else:
            print("Binary is present: %s" % bin_name)

    return package_updated
