# -*- coding: utf-8 -*-
from setuphelpers import *


def install():
    bin_name = glob.glob("Freeplane-Setup-with-Java-*.exe")[0]
    install_exe_if_needed(
        bin_name,
        silentflags="/VERYSILENT /SUPPRESSMSGBOXES /NORESTART",
        key="{D3941722-C4DD-4509-88C4-0E87F675A859}_is1",
        min_version=control.get_software_version(),
        timeout=600,
    )


def install():
    # Declaring local variables
    bin_name = glob.glob("Linphone-*-win64.exe")[0]

    # Uninstalling older major versions of the software
    for to_uninstall in installed_softwares(uninstallkey="Linphone"):
        if Version(to_uninstall["version"], 1) < Version(control.get_software_version(), 1) or force:
            print("Removing: %s (%s)" % (to_uninstall["name"], to_uninstall["version"]))
            killalltasks(ensure_list(control.impacted_process))
            run(uninstall_cmd(to_uninstall["key"]))
            wait_uninstallkey_absent(to_uninstall["key"])

    # Installing the software
    install_exe_if_needed(
        bin_name,
        silentflags="/S",
        key="Linphone",
        min_version=control.get_software_version(),
        timeout=600,
    )
