def uninstall():
    # Uninstalling the software
    for to_uninstall in installed_softwares(app_name):
        print("Removing: %s (%s)" % (to_uninstall["name"], to_uninstall["version"]))
        killalltasks(ensure_list(control.impacted_process))
        run(uninstall_cmd(to_uninstall["key"]))
        wait_uninstallkey_absent(to_uninstall["key"])

    # Uninstalling the additionnal softwares
    other_keys = ["{CF1EB598-B424-436A-B15F-B763846BA970}", "{F2F2DEA7-36AB-4E13-907C-D8BDE775EF97}"]
    for key in other_keys:
        to_uninstall = installed_softwares(uninstallkey=key)
        if to_uninstall:
            to_uninstall = to_uninstall[0]
        else:
            continue
        print("Removing: %s (%s)" % (to_uninstall["name"], to_uninstall["version"]))
        killalltasks(ensure_list(control.impacted_process))
        run(uninstall_cmd(to_uninstall["key"]))
        wait_uninstallkey_absent(to_uninstall["key"])

    # Uninstalling the software and remove app_dir
    for to_uninstall in installed_softwares(app_name):
        print("Removing: %s (%s)" % (to_uninstall["name"], to_uninstall["version"]))
        killalltasks(ensure_list(control.impacted_process))
        run(uninstall_cmd(to_uninstall["key"]))
        wait_uninstallkey_absent(to_uninstall["key"])
        if isdir(to_uninstall["install_location"]):
            remove_tree(to_uninstall["install_location"])

    # Uninstalling the software and crashing if unsuccessful
    for to_uninstall in installed_softwares(app_name):
        print("Removing: %s (%s)" % (to_uninstall["name"], to_uninstall["version"]))
        killalltasks(ensure_list(control.impacted_process))
        run(uninstall_cmd(to_uninstall["key"]))
        try:
            wait_uninstallkey_absent(to_uninstall["key"], raise_on_timeout=True)
        except Exception as e:
            print(f"ERROR: {e}")
            error(f"Silent uninstall of: %s (%s) failed.\nYou must uninstall it manually." % (to_uninstall["name"], to_uninstall["version"]))

    # Uninstalling the software if install is forced
    if force:
        for to_uninstall in installed_softwares(name="Java 8"):
            if "Oracle" in to_uninstall["publisher"]:
                print("Removing: %s (%s)" % (to_uninstall["name"], to_uninstall["version"]))
                killalltasks(ensure_list(control.impacted_process))
                run(uninstall_cmd(to_uninstall["key"]))
                wait_uninstallkey_absent(to_uninstall["key"])
                if isdir(to_uninstall["install_location"]):
                    remove_tree(to_uninstall["install_location"])

    # Uninstall the older versions of the software  # it seems necessary for Linphone
    for to_uninstall in installed_softwares(uninstallkey="Linphone"):
        if Version(to_uninstall["version"]) < Version(control.get_software_version()) or force:
            print("Removing: %s (%s)" % (to_uninstall["name"], to_uninstall["version"]))
            killalltasks(ensure_list(control.impacted_process))
            run(uninstall_cmd(to_uninstall["key"]))
            wait_uninstallkey_absent(to_uninstall["key"])
            # if isdir(to_uninstall["install_location"]):
            #     remove_tree(to_uninstall["install_location"])

    # Uninstalling older major versions of the software
    for to_uninstall in installed_softwares(name="^Microsoft Edge$"):
        if Version(to_uninstall["version"], 1) < Version(control.get_software_version(), 1) or force:
            print("Removing: %s (%s)" % (to_uninstall["name"], to_uninstall["version"]))
            killalltasks(ensure_list(control.impacted_process))
            run(uninstall_cmd(to_uninstall["key"]))
            wait_uninstallkey_absent(to_uninstall["key"])

    # Uninstalling other versions of the software
    for to_uninstall in installed_softwares(name="^Microsoft Edge$"):
        if Version(to_uninstall["version"]) != Version(control.get_software_version()) or force:
            print("Removing: %s (%s)" % (to_uninstall["name"], to_uninstall["version"]))
            try:
                killalltasks(ensure_list(control.impacted_process))
                run(uninstall_cmd(to_uninstall["key"]))
                wait_uninstallkey_absent(to_uninstall["key"])
            except Exception as e:
                print(e)
                print("Remove failed: %s (%s)\nContinuing..." % (to_uninstall["name"], to_uninstall["version"]))

    # Uninstalling the other architecture of the software
    for to_uninstall in installed_softwares(name="Java 8"):
        if "Oracle" in to_uninstall["publisher"]:
            if "x64" in ensure_list(control.architecture) and not to_uninstall["win64"] or force:
                print("Removing: %s (%s)" % (to_uninstall["name"], to_uninstall["version"]))
                killalltasks(ensure_list(control.impacted_process))
                run(uninstall_cmd(to_uninstall["key"]))
                wait_uninstallkey_absent(to_uninstall["key"])
                if isdir(to_uninstall["install_location"]):
                    remove_tree(to_uninstall["install_location"])

    # Uninstalling the software using different uninstall_string
    for to_uninstall in installed_softwares(uninstallkey=app_uninstallkey):
        print("Removing: %s (%s)" % (to_uninstall["name"], to_uninstall["version"]))
        killalltasks(ensure_list(control.impacted_process))
        app_uninstall_cmd = to_uninstall["uninstall_string"] + " --force-uninstall"
        run(app_uninstall_cmd, accept_returncodes=[0, 3010, 19])
        wait_uninstallkey_absent(to_uninstall["key"])

    # Uninstalling the software using different uninstall_string
    for to_uninstall in installed_softwares(uninstallkey=app_uninstallkey):
        print("Removing: %s (%s)" % (to_uninstall["name"], to_uninstall["version"]))
        killalltasks(ensure_list(control.impacted_process))
        app_uninstall_cmd = uninstall_cmd(to_uninstall["key"])
        app_uninstall_cmd.append("/s")
        run(app_uninstall_cmd)
        wait_uninstallkey_absent(to_uninstall["key"])

    # Force uninstalling the software
    for to_uninstall in installed_softwares(name="^Microsoft Edge$"):
        print("Removing: %s (%s)" % (to_uninstall["name"], to_uninstall["version"]))
        killalltasks(ensure_list(control.impacted_process))
        try:
            run(uninstall_cmd(to_uninstall["key"]))
            wait_uninstallkey_absent(to_uninstall["key"], max_loop=60)
        except Exception as e:
            print(e)
            time.sleep(60)
            unregister_uninstall(to_uninstall["key"], win64app=to_uninstall["win64"])
            if isdir(to_uninstall["install_location"]):
                remove_tree(to_uninstall["install_location"])

    # Force uninstalling older versions of the software
    for to_uninstall in installed_softwares(name="PuTTY "):
        if Version(to_uninstall["version"]) < Version(control.get_software_version()) or force:
            print("Removing: %s (%s)" % (to_uninstall["name"], to_uninstall["version"]))
            killalltasks(ensure_list(control.impacted_process))
            try:
                run(uninstall_cmd(to_uninstall["key"]))
                wait_uninstallkey_absent(to_uninstall["key"], max_loop=60, raise_on_timeout=True)
            except Exception as e:
                print(e)
                time.sleep(60)
                unregister_uninstall(to_uninstall["key"], win64app=to_uninstall["win64"])
                if isdir(to_uninstall["install_location"]):
                    remove_tree(to_uninstall["install_location"])

    # Uninstalling newer versions of the software for older Windows versions than Windows 10
    if windows_version() < WindowsVersions.Windows10:
        for to_uninstall in installed_softwares(name="^Microsoft Edge$"):
            if Version(to_uninstall["version"]) > Version(control.get_software_version()) or force:
                print("Removing: %s (%s)" % (to_uninstall["name"], to_uninstall["version"]))
                try:
                    killalltasks(ensure_list(control.impacted_process))
                    run(uninstall_cmd(to_uninstall["key"]))
                    wait_uninstallkey_absent(to_uninstall["key"])
                except Exception as e:
                    print(e)
                    print("Remove failed: %s (%s)\nContinuing..." % (to_uninstall["name"], to_uninstall["version"]))

    # Uninstalling other versions of the software installed in another path
    for to_uninstall in installed_softwares(name="^FortiClient VPN$"):
        install_app_dir = makepath(to_uninstall["install_location"], os.sep)
        if makepath(to_uninstall["install_location"], os.sep) != makepath(app_dir, os.sep) or force:
            print("Removing: %s (%s)" % (to_uninstall["name"], to_uninstall["version"]))
            killalltasks(ensure_list(control.impacted_process))
            run(uninstall_cmd(to_uninstall["key"]))
            wait_uninstallkey_absent(to_uninstall["key"])


def wait_uninstallkey_absent(key=None, max_loop=120, keywords=None, name=None, raise_on_timeout=False):
    if len([f for f in [key, keywords, name] if f]) > 1:
        error("Arguments conflict key: %s keywords: %s name: %s" % (key, keywords, name))

    if key:
        searchparam = "key: %s" % str(key)
    elif name:
        searchparam = "name: %s" % str(name)
    else:
        searchparam = "keywords: %s" % str(keywords)
    print("Waiting for the removal of %s from Windows registry" % searchparam)
    loop = 0
    while uninstall_key_exists(key, keywords=keywords, name=name):
        loop += 1
        if loop > max_loop:
            if raise_on_timeout:
                error("timeout after %s seconds" % max_loop)
            else:
                return "timeout after %s seconds" % max_loop
        time.sleep(1)


def removing_extra_edge_apps():
    for to_uninstall in installed_softwares(name="Microsoft Edge "):
        if not to_uninstall["uninstall_string"]:
            unregister_uninstall(uninstallkey=to_uninstall["key"])
            continue
        print("Removing: %s (%s)" % (to_uninstall["name"], to_uninstall["version"]))
        uninstall_app_cmd = to_uninstall["uninstall_string"] + " --force-uninstall"
        run_notfatal(uninstall_app_cmd)
        wait_uninstallkey_absent(to_uninstall["key"])
