#!waptpython
# -*- coding: utf-8 -*-
import os
import sys

sys.path.insert(0, os.path.dirname(os.path.realpath(__file__)))
from setupdevhelpers import *
from dev_utils import *

sys.path.insert(0, sys.executable.rsplit(os.path.sep, 1)[0].replace("/bin", "").replace("\\Scripts", ""))
from setuphelpers import *


def update_luti_json(luti_json_path):
    """This function updates a luti.json file with new properties and values"""
    # update_repo()
    luti_json_template_path = makepath(get_package_tools_path(), "luti-json", "luti-all_params.json")

    # Open the file for reading
    with open(luti_json_template_path, "r") as file:
        luti_content = json.load(file)

    if isfile(luti_json_path):
        with open(luti_json_path, "r") as file:
            luti_dict = json.load(file)
    else:
        luti_dict = {}

    # transform luti_content into a list of dictionaries
    luti_list = []
    for key in luti_content:
        # check if luti_dict has the key
        if key in luti_dict:
            luti_list.append({"property": key, "exemple": luti_content[key], "value": luti_dict[key]})
        else:
            luti_list.append({"property": key, "exemple": luti_content[key], "value": ""})

    property_to_change = ask_grid(
        "Press F2 to change a property",
        luti_list,
        0,
        '{"columns":[{"propertyname":"property","datatype":"String","required":false,"readonly":false,"width":249},{"propertyname":"exemple","datatype":"String","required":false,"readonly":false,"width":253},{"propertyname":"value","datatype":"String","required":false,"readonly":false,"width":202}]}',
    )
    new_luti_dict = {}

    for item in property_to_change:
        if item["value"] != "":
            new_luti_dict.update({item["property"]: item["value"]})

    with open(luti_json_path, "w") as file:
        json.dump(new_luti_dict, file, indent=4)


# ask where the luti.json file is or will be
luti_json_folder = ask_directory("Select the folder where you want to add the luti file")
# get target luti.json path
luti_json_path = makepath(luti_json_folder, "luti.json")

update_luti_json(luti_json_path)
